searchNodes=[{"doc":"The Blogit Application module for the application :blogit. The application is started using this module and can be used through the public interface it provides. What is Blogit? Blogit is a blog engine. It uses a repository (by default a git repository) containing markdown files to build posts and configuration for a blog. It can be used by, for example, Phoenix application as a back-end. One such Phoenix application is Blogit Web. An example of a running blog which uses Blogit and Blogit Web is the blog of the Elixir Course of the Sofia University : blog.elixir-lang.bg. Its git repository, can be found here https://github.com/ElixirCourse/blog. Yes, Blogit is the Elixir version of Octopress. That said, Blogit is very extensible - the repository it uses can be something other than a Git one. For example it could be FTP, local file system, Mnesia, Postgres, etc... The only thing needed is to implement the Blogit.RepositoryProvider behaviour and to configure Blogit to use it: Example (config/prod.exs): config :blogit, repository_url: &quot;some_protocol://some_location.net&quot;, repository_provider: Blogit.RepositoryProviders.MyProvider For now the post files have to be in markdown, but this will be configurable too. The meta-data of a post is in YAML which could be included in the markdown source file of the post, in the beginning. As Blogit is simple OTP Application with very simple public interface, presented by this module, it can have custom front-end too. It can be Phoenix+HTLM, Phoenix+React.js, Phoenix+ELM, it can be just some Plug application, it can use :gen_tcp or be some blog-in-the-terminal. So Blogit is blog engine by a programmer for programmers.","ref":"Blogit.html","title":"Blogit","type":"module"},{"doc":"Retrieves the blog configuration. The configuration is in the form of a Blogit.Models.Configuration struct. The configuration is generated from an YML file (by default blog.yml, stored in the root of the repository of the blog). This location can be configured through setting the :configuration_file key of the :blogit configuration. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Configuration for the given language will be returned.","ref":"Blogit.html#configuration/1","title":"Blogit.configuration/1","type":"function"},{"doc":"Returns a list of Blogit.Models.Post.Meta structs, filtered by given criteria. The first argument of the function is a map of filters. This map supports zero or more of the following key-values: &quot;author&quot; - Used to filter posts by their .meta.author field. &quot;category&quot; - Used to filter posts by their .meta.category field. &quot;tags&quot; - Used to filter posts by their .meta.tags field. The value for this key should a string of comma separated tags. &quot;year&quot; - Used to filter posts by their .meta.year field. &quot;month&quot; - Used to filter posts by their .meta.month field. &quot;q&quot; - A query to filter posts by their content or title. Supports text in double quotes in order to search for phrases. For more information on the filtering see Blogit.Logic.Search.filter_by_params/2. Options :from (non-negative integer) - all the posts meeting the given filtering criteria for the given/default language ordered by their creation date and with indexes smaller than the value of this option will be skipped and not present in the result list of posts list. Defaults to 0. Can be used along with the :size option to implement simple paging. :size (positive integer or :infinity) - the maximum number of posts in the result. By default it is :infinity. Can be used along with the :from option to implement simple paging. :language - different sets of posts can exist for every language configured. This option can be used to specify which of these sets should be used as the source of the posts to be returned. By default posts of the default language will be returned.","ref":"Blogit.html#filter_posts/2","title":"Blogit.filter_posts/2","type":"function"},{"doc":"Returns a list of tuples. Every such tuple has the unique name of a post as first element and its title as second. These tuples are sorted by the last updated date of the posts they represent. All the markdown files in the source posts folder will be transformed into Blogit.Models.Post structs and their updated_at meta field will be read using the configured Blogit.RepositoryProvider. Pinned posts are posts which have specified pinned: true in their meta data. These are special posts which should be easy to find in the front-end implementation. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Pinned post tuples for the given language will be returned.","ref":"Blogit.html#list_pinned/1","title":"Blogit.list_pinned/1","type":"function"},{"doc":"Returns a list of Blogit.Models.Post.Meta structs representing posts in the blog. The posts are sorted by their creation date, newest first. All the markdown files in the posts folder will be transformed into Blogit.Models.Post structs and their created_at meta field will be read using the configured Blogit.RepositoryProvider. The &#39;meta&#39; fields of every post include a preview field. Its value is HTML preview of the post. The provider implementation should search (by default) for posts in a posts folder, which should be located at the root of the git repository. Example configuration (config/prod.exs): config :blogit, repository_url: &quot;some_protocol://some_location.net&quot;, repository_provider: Blogit.RepositoryProviders.MyProvider, languages: [&quot;en&quot;, &quot;bg&quot;] Options :from (non-negative integer) - all the posts for the given/default language ordered by their creation date and with indexes smaller than the value of this option will be skipped and not present in the result list of post meta data. Can be used along with the :size option to implement simple paging. Defaults to 0. :size (positive integer or :infinity) - the maximum number of post meta structs in the result. By default it is :infinity. Can be used along with the :from option to implement simple paging. :language - different sets of posts can exist for every language configured. This option can be used to specify which of these sets should be used as the source of the post meta data to be returned. By default posts of the default language will be returned. Example posts = Blogit.list_posts(from: 5, size: 10, language: &quot;es&quot;)","ref":"Blogit.html#list_posts/1","title":"Blogit.list_posts/1","type":"function"},{"doc":"Returns a single post by its unique identifier - its name field. The name should be an atom. The result is in the form {:ok, post} if a post with the given name exist for the given (or default) language. The post element of that tuple is a Blogit.Models.Post struct. Posts have unique names, usually constructed using the file path of their source markdown file in the repository. If there is no post with the given name, the tuple {:error, &quot;No post with name the-passed-name found.&quot;} is returned. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Post with the given name in the given language will be returned if found.","ref":"Blogit.html#post_by_name/2","title":"Blogit.post_by_name/2","type":"function"},{"doc":"Returns a list of tuples of three elements from the given list of posts. The first element of a tuple is a year. The second is a month number. The third is a counter - how many posts are created during that month and that year. Can be used for implementing an easy-to-browse view component by years/months. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Statistics for the posts in the given language will be returned. For more information see Blogit.Models.Post.collect_by_year_and_month/1.","ref":"Blogit.html#posts_by_dates/1","title":"Blogit.posts_by_dates/1","type":"function"},{"doc":"Callback implementation for Application.start/2.","ref":"Blogit.html#start/2","title":"Blogit.start/2","type":"function"},{"doc":"","ref":"Blogit.html#t:filters/0","title":"Blogit.filters/0","type":"type"},{"doc":"The Blogit Application module for the application :blogit.","ref":"Blogit.Application.html","title":"Blogit.Application","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Blogit.Application.html#start/2","title":"Blogit.Application.start/2","type":"function"},{"doc":"Contains common logic for creating and naming Blogit component processes. A component is a GenServer, but instead declaring: use GenServer it should declare: use Blogit.Component This will make it a GenServer and will create the start_link/1 function for creating the component process for the module. This will also add the name/1 function, which creates uniq name/id for the component based on the given language. This name/id is used by the Blogit.Components.Supervisor process.","ref":"Blogit.Component.html","title":"Blogit.Component","type":"module"},{"doc":"A Blogit.Component process which can be queried from outside. The Blogit.Components.Configuration process holds the configuration of the blog. This process handles one call - :get. When received, the configuration of the blog is returned in the form of Blogit.Models.Configuration struct. This component is supervised by Blogit.Components.Supervisor and added to it by Blogit.Server. When the configuration gets updated, this process&#39; state is updated by the Blogit.Server process.","ref":"Blogit.Components.Configuration.html","title":"Blogit.Components.Configuration","type":"module"},{"doc":"Returns the base name, which identifies the process. For example it could be posts.","ref":"Blogit.Components.Configuration.html#base_name/0","title":"Blogit.Components.Configuration.base_name/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Components.Configuration.html#child_spec/1","title":"Blogit.Components.Configuration.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Blogit.Components.Configuration.html#init/1","title":"Blogit.Components.Configuration.init/1","type":"function"},{"doc":"Returns the name, which identifies the process. It is composed using the base_name/0 and the given language. For example if the base_name/0 returns posts and the given language is en, the name will be posts_en. The worker id registered under the Blogit.Components.Supervisor will be the name returned by this function, when start_link/1 is called to create the process. The language passed to it (or the one returned from Blogit.Settings.default_language/0) will be passed to name/1 to create the name.","ref":"Blogit.Components.Configuration.html#name/1","title":"Blogit.Components.Configuration.name/1","type":"function"},{"doc":"Starts the GenServer process. The process is started and supervised by Blogit.Components.Supervisor and the specification of it is added by Blogit.Server. The state of the process in the beginning is nil. The process should keep the given language passed to init/1 as the first of a tuple as part of its state. This process should serve requests related to that language. The given state_provider is the second element of the tuple passed to GenServer.init/1. It could be used to retrieve the state of the process. By default the language is the one returned by Blogit.Settings.default_language/0 and the state_provider is Blogit.Server.","ref":"Blogit.Components.Configuration.html#start_link/2","title":"Blogit.Components.Configuration.start_link/2","type":"function"},{"doc":"A Blogit.Component process which can be queried from outside. The Blogit.Components.Metas process holds the meta data for all the posts in the blog as its state. For some queries only the meta data of the posts is needed and quering this component for it is cheaper than retrieving it from the Blogit.Components.Posts one. Also the messages with only meta data are much smaller, as they only include the preview HTML of the posts and not the whole content. This process handles the following call messages: {:list, from, size} -&gt; returns a list of post metas sorted by their created_at field, newest first. The first from are dropped and the size of the result list is specified by size. The size can be :infinity. :list_pinned -&gt; returns a list of tuples representing posts, sorted by the post&#39;s meta.updated_at field, newest first, only if their pinned field is true. The tuples consist of two elements the first is the uniq name of the post and the second - its title. This component is supervised by Blogit.Components.Supervisor and added to it by Blogit.Server. When the posts get updated, this process&#39; state is reset to nil and on the next request to it, it is re-calculated.","ref":"Blogit.Components.Metas.html","title":"Blogit.Components.Metas","type":"module"},{"doc":"Returns the base name, which identifies the process. For example it could be posts.","ref":"Blogit.Components.Metas.html#base_name/0","title":"Blogit.Components.Metas.base_name/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Components.Metas.html#child_spec/1","title":"Blogit.Components.Metas.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Blogit.Components.Metas.html#init/1","title":"Blogit.Components.Metas.init/1","type":"function"},{"doc":"Returns the name, which identifies the process. It is composed using the base_name/0 and the given language. For example if the base_name/0 returns posts and the given language is en, the name will be posts_en. The worker id registered under the Blogit.Components.Supervisor will be the name returned by this function, when start_link/1 is called to create the process. The language passed to it (or the one returned from Blogit.Settings.default_language/0) will be passed to name/1 to create the name.","ref":"Blogit.Components.Metas.html#name/1","title":"Blogit.Components.Metas.name/1","type":"function"},{"doc":"Starts the GenServer process. The process is started and supervised by Blogit.Components.Supervisor and the specification of it is added by Blogit.Server. The state of the process in the beginning is nil. The process should keep the given language passed to init/1 as the first of a tuple as part of its state. This process should serve requests related to that language. The given state_provider is the second element of the tuple passed to GenServer.init/1. It could be used to retrieve the state of the process. By default the language is the one returned by Blogit.Settings.default_language/0 and the state_provider is Blogit.Server.","ref":"Blogit.Components.Metas.html#start_link/2","title":"Blogit.Components.Metas.start_link/2","type":"function"},{"doc":"A Blogit.Component process which can be queried from outside. The Blogit.Components.Posts process holds all the posts in the blog as its state. This process handles the following call messages: :all -&gt; returns all the posts of the blog as list of Blogit.Models.Post structures. {:filter, filters, from, size} -&gt; returns a list of posts sorted by their meta.created_at field, newest first, filtered by the given filters and the first from are dropped. The size of the list is specified by size. The posts are represented by Blogit.Models.Post.Meta structures so they can be presented in a stream by showing only their preview. {:by_name, name} -&gt; returns one post by its unique name. If there is no post with the given name the tuple {:error, no-post-found-message} is returned. If the post is present, the tuple {:ok, the-post} is returned. The post is in the for of a Blogit.Models.Post struct. This component is supervised by Blogit.Components.Supervisor and added to it by Blogit.Server. When the posts get updated, this process&#39; state is updated by the Blogit.Server process. The Blogit.Components.PostsByDate and the Blogit.Components.Metas processes calculate their state using this one.","ref":"Blogit.Components.Posts.html","title":"Blogit.Components.Posts","type":"module"},{"doc":"Returns the base name, which identifies the process. For example it could be posts.","ref":"Blogit.Components.Posts.html#base_name/0","title":"Blogit.Components.Posts.base_name/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Components.Posts.html#child_spec/1","title":"Blogit.Components.Posts.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Blogit.Components.Posts.html#init/1","title":"Blogit.Components.Posts.init/1","type":"function"},{"doc":"Returns the name, which identifies the process. It is composed using the base_name/0 and the given language. For example if the base_name/0 returns posts and the given language is en, the name will be posts_en. The worker id registered under the Blogit.Components.Supervisor will be the name returned by this function, when start_link/1 is called to create the process. The language passed to it (or the one returned from Blogit.Settings.default_language/0) will be passed to name/1 to create the name.","ref":"Blogit.Components.Posts.html#name/1","title":"Blogit.Components.Posts.name/1","type":"function"},{"doc":"Starts the GenServer process. The process is started and supervised by Blogit.Components.Supervisor and the specification of it is added by Blogit.Server. The state of the process in the beginning is nil. The process should keep the given language passed to init/1 as the first of a tuple as part of its state. This process should serve requests related to that language. The given state_provider is the second element of the tuple passed to GenServer.init/1. It could be used to retrieve the state of the process. By default the language is the one returned by Blogit.Settings.default_language/0 and the state_provider is Blogit.Server.","ref":"Blogit.Components.Posts.html#start_link/2","title":"Blogit.Components.Posts.start_link/2","type":"function"},{"doc":"A Blogit.Component process which can be queried from outside. This process handles a :get message which returns a list of tuples of three elements - {&lt;year&gt;, &lt;month&gt;, &lt;number-of-posts&gt;}. It is statistics data - for this year and this month the blog has N posts. This component is supervised by Blogit.Components.Supervisor and added to it by Blogit.Server. It is lazy, the first time it is queried it computes its state by using the Blogit.Components.Posts process&#39; state. When the posts get updated, this process&#39; state is reset to nil and on the next request to it, it is re-calculated.","ref":"Blogit.Components.PostsByDate.html","title":"Blogit.Components.PostsByDate","type":"module"},{"doc":"Returns the base name, which identifies the process. For example it could be posts.","ref":"Blogit.Components.PostsByDate.html#base_name/0","title":"Blogit.Components.PostsByDate.base_name/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Components.PostsByDate.html#child_spec/1","title":"Blogit.Components.PostsByDate.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Blogit.Components.PostsByDate.html#init/1","title":"Blogit.Components.PostsByDate.init/1","type":"function"},{"doc":"Returns the name, which identifies the process. It is composed using the base_name/0 and the given language. For example if the base_name/0 returns posts and the given language is en, the name will be posts_en. The worker id registered under the Blogit.Components.Supervisor will be the name returned by this function, when start_link/1 is called to create the process. The language passed to it (or the one returned from Blogit.Settings.default_language/0) will be passed to name/1 to create the name.","ref":"Blogit.Components.PostsByDate.html#name/1","title":"Blogit.Components.PostsByDate.name/1","type":"function"},{"doc":"Starts the GenServer process. The process is started and supervised by Blogit.Components.Supervisor and the specification of it is added by Blogit.Server. The state of the process in the beginning is nil. The process should keep the given language passed to init/1 as the first of a tuple as part of its state. This process should serve requests related to that language. The given state_provider is the second element of the tuple passed to GenServer.init/1. It could be used to retrieve the state of the process. By default the language is the one returned by Blogit.Settings.default_language/0 and the state_provider is Blogit.Server.","ref":"Blogit.Components.PostsByDate.html#start_link/2","title":"Blogit.Components.PostsByDate.start_link/2","type":"function"},{"doc":"Represents a Supervisor, which supervises the components worker processes. By default this Supervisor starts with no children. Blogit.Supervisor starts a supervisor process implementing this module first and after it a Blogit.Server worker process. When the Blogit.Server becomes active and loads all of the source repository data into itself, it creates the component specifications and adds them to the Blogit.Components.Supervisor process. This supervisor uses one_for_one strategy for its workers as they are not dependent on each other. They are dependent on the Blogit.Server process, so if it dies, this supervisor is restated and its child processes are added by the newly restarted Blogit.Server process. Every type of component will have a process for every language configured for Blogit with its unique id. For example if Blogit is configured to support bg and en, the Blogit.Components.Posts module will have two worker processes, one with id posts_bg and one with posts_en. Every language configured has its own set of data and processes, which are isolated from the data and the processes of the other languages.","ref":"Blogit.Components.Supervisor.html","title":"Blogit.Components.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Components.Supervisor.html#child_spec/1","title":"Blogit.Components.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Blogit.Components.Supervisor.html#init/1","title":"Blogit.Components.Supervisor.init/1","type":"function"},{"doc":"Starts the Blogit.Components.Supervisor process. The strategy of the Blogit.Components.Supervisor is one_for_one and it starts with no children specifications. The specifications of the components are added to it by the Blogit.Server worker process once it can accept messages and has the data needed by the component processes as its state. Examples iex&gt; {:ok, pid} = Blogit.Components.Supervisor.start_link() iex&gt; is_pid(pid) true iex&gt; {:ok, pid} = Blogit.Components.Supervisor.start_link() iex&gt; Process.alive?(pid) true iex&gt; {:ok, pid} = Blogit.Components.Supervisor.start_link() iex&gt; Supervisor.count_children(pid) %{active: 0, specs: 0, supervisors: 0, workers: 0} iex&gt; {:ok, pid} = Blogit.Components.Supervisor.start_link() iex&gt; elem(:sys.get_state(pid), 2) # strategy :one_for_one","ref":"Blogit.Components.Supervisor.html#start_link/0","title":"Blogit.Components.Supervisor.start_link/0","type":"function"},{"doc":"","ref":"Blogit.Listener.html","title":"Blogit.Listener","type":"behaviour"},{"doc":"","ref":"Blogit.Listener.html#c:handle_event/1","title":"Blogit.Listener.handle_event/1","type":"callback"},{"doc":"Contains a function for filtering and searching posts. Lists of Blogit.Models.Post structures can be filtered by &#39;author&#39;, &#39;category&#39;, &#39;tags&#39;, &#39;year&#39; and &#39;month&#39;. The content and the title of lists of Blogit.Models.Posts can be searched using a query.","ref":"Blogit.Logic.Search.html","title":"Blogit.Logic.Search","type":"module"},{"doc":"Filters a list of Blogit.Models.Post structs using a map of meta fields to filter by and/or search query to match to their contents and/or titles. The params parameter supports zero or more of the following keys: &quot;author&quot; - Used to filter Blogit.Models.Post structs by their .meta.author field. &quot;category&quot; - Used to filter Blogit.Models.Post structs by their .meta.category field. &quot;tags&quot; - Used to filter Blogit.Models.Post structs by their .meta.tags field. The value for this key should a string of comma separated tags. &quot;year&quot; - Used to filter Blogit.Models.Post by their .meta.year field. &quot;month&quot; - Used to filter Blogit.Models.Post by their .meta.month field. &quot;q&quot; - A query to filter Blogit.Models.Post structs by their content or title. Support text in double quotes in order to search for phrases. If the map contains other keys, they&#39;ll be ignored. Examples iex&gt; alias Blogit.Models.Post.Meta iex&gt; posts = [ ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;one&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;meddle&quot;, category: &quot;Primary&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;two&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;valo&quot;, category: &quot;Secondary&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;three&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;Reductions&quot;, category: &quot;Other&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;four&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;meddle&quot;, category: &quot;Other&quot;} ...&gt; } ...&gt; ] iex&gt; filter = %{&quot;author&quot; =&gt; &quot;meddle&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;, &quot;four&quot;] iex&gt; filter = %{&quot;category&quot; =&gt; &quot;Other&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;three&quot;, &quot;four&quot;] iex&gt; alias Blogit.Models.Post.Meta iex&gt; posts = [ ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;one&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{tags: [&quot;one&quot;, &quot;едно&quot;, &quot;super&quot;]} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;two&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{tags: [&quot;two&quot;, &quot;две&quot;, &quot;super&quot;]} ...&gt; } ...&gt; ] iex&gt; filter = %{&quot;tags&quot; =&gt; &quot;super, one&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;] iex&gt; alias Blogit.Models.Post.Meta iex&gt; posts = [ ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;one&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{year: &quot;2017&quot;, month: &quot;4&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;two&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{year: &quot;2016&quot;, month: &quot;4&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;three&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{year: &quot;2017&quot;, month: &quot;3&quot;} ...&gt; } ...&gt; ] iex&gt; filter = %{&quot;year&quot; =&gt; &quot;2017&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;, &quot;three&quot;] iex&gt; filter = %{&quot;month&quot; =&gt; &quot;4&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;, &quot;two&quot;] iex&gt; filter = %{&quot;month&quot; =&gt; &quot;4&quot;, &quot;year&quot; =&gt; &quot;2017&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;] iex&gt; alias Blogit.Models.Post.Meta iex&gt; posts = [ ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;one&quot;, raw: &quot;Something about Processes - stuff&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;meddle&quot;, title: &quot;Processes&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;two&quot;, raw: &quot;Modules contain functions!&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;valo&quot;, title: &quot;Modules And Functions&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;three&quot;, raw: &quot;Mix is one of the coolest things&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;Reductions&quot;, title: &quot;Mix And Tests&quot;} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;four&quot;, raw: &quot;Linked things make difference&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{author: &quot;meddle&quot;, title: &quot;Processes And Links&quot;} ...&gt; } ...&gt; ] iex&gt; filter = %{&quot;q&quot; =&gt; &quot;Process&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;one&quot;, &quot;four&quot;] iex&gt; filter = %{&quot;q&quot; =&gt; &quot;Tests&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;three&quot;] iex&gt; filter = %{&quot;q&quot; =&gt; ~s(&quot;coolest things&quot;)} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) [&quot;three&quot;] iex&gt; filter = %{&quot;q&quot; =&gt; ~s(&quot;coolest things&quot;), &quot;author&quot; =&gt; &quot;meddle&quot;} iex&gt; filtered = Blogit.Logic.Search.filter_by_params(posts, filter) iex&gt; filtered |&gt; Enum.map(fn (post) -&gt; post.name end) []","ref":"Blogit.Logic.Search.html#filter_by_params/2","title":"Blogit.Logic.Search.filter_by_params/2","type":"function"},{"doc":"","ref":"Blogit.Logic.Search.html#t:posts/0","title":"Blogit.Logic.Search.posts/0","type":"type"},{"doc":"","ref":"Blogit.Logic.Search.html#t:search_value/0","title":"Blogit.Logic.Search.search_value/0","type":"type"},{"doc":"Contains the function check_updates/1 for checking for new updates using a Blogit.RepositoryProvider module implementation. Checking for updates should be done in a specific process, so the main posts repository is not blocked while checking for updates.","ref":"Blogit.Logic.Updater.html","title":"Blogit.Logic.Updater","type":"module"},{"doc":"Checks for new updates of the state in the remote/local repository. The state should contain a Blogit.RepositoryProvider struct. If there are no updates in the repository, the atom :no_updates is returned. If there are updates in the repository, a tuple of two elements is returned: { :updates, %{posts: &lt;updated-posts-as-map&gt;, configurations: &lt;updated-configuration&gt;} } This function is called in a supervised Task by the Blogit.Server process.","ref":"Blogit.Logic.Updater.html#check_updates/1","title":"Blogit.Logic.Updater.check_updates/1","type":"function"},{"doc":"","ref":"Blogit.Logic.Updater.html#t:check_updates_result/0","title":"Blogit.Logic.Updater.check_updates_result/0","type":"type"},{"doc":"A module for managing and reading the blog configuration. A repository containing the blog data can also contain an &#39;yml&#39; configuration file. The file should be in the form title: &lt;title&gt; sub_title: &lt;a-sub-title-for-the-blog&gt; logo_path: &lt;path to logo for the blog&gt; background_image_path: &lt;path to image at the top of the feed as background&gt; styles_path: &lt;path to css file with custom styles for the blog&gt; social: rss: &lt;show-rss-feed&gt;(true/false) stars_for_blogit: &lt;show-give-stars-for-blogit-links&gt;(true/false) twitter: &lt;twitter-id&gt; facebook: &lt;facebook-id&gt; gihub: &lt;github-id&gt; All of these properties are optional and there are defaults for them. For example the default title of the blog is the transformed name of the repository (name: &#39;my_repo&#39; |&gt; title: &#39;My Repo&#39;). For every language code, returned by Blogit.Settings.languages/0 the file can have sub-section with custom settings. The configurations for the additional languages extend on the configuration of the default language. title: &lt;title&gt; sub_title: &lt;a-sub-title-for-the-blog&gt; logo_path: &lt;path to logo for the blog&gt; background_image_path: &lt;path to image at the top of the feed as background&gt; styles_path: &lt;path to css file with custom styles for the blog&gt; social: rss: &lt;show-rss-feed&gt;(true/false) stars_for_blogit: &lt;show-give-stars-for-blogit-links&gt;(true/false) twitter: &lt;twitter-id&gt; facebook: &lt;facebook-id&gt; gihub: &lt;github-id&gt; bg: title: &lt;title-in-bulgarian&gt; If the default language is en for English in the above example, the configuration for the Bulgarian language (bg) will be the same as the English one, but will another title, the one specified under bg. All the other supported keys can have custom values under bg.","ref":"Blogit.Models.Configuration.html","title":"Blogit.Models.Configuration","type":"module"},{"doc":"Creates a list of Blogit.Post.Configuration struct from the configuration source file contents. The list includes configuration for every configured language. The first item of the list is the configuration for the default language (The one returned by invoking Blogit.Settings.default_language/0). The name and the location of the file are read from the configuration of Blogit - the configuration property configuration_file. If the file doesn&#39;t exist or it is invalid YML file, the structure is created using the defaults. The defaults are: title - the name of the repository of the blog. sub_title - nil local_path - nil background_image_path - nil styles_path - nil social: %{&quot;rss&quot; =&gt; true, &quot;stars_for_blogit&quot; =&gt; true} language: : for every language returned by [`Blogit.Settings.languages/0`](Blogit.Settings.html#languages/0) a configuration struct will be created and returned by this function.","ref":"Blogit.Models.Configuration.html#from_file/1","title":"Blogit.Models.Configuration.from_file/1","type":"function"},{"doc":"Checks if the name of the configuration file of the blog is in the given list containing updated file names. Examples iex&gt; Blogit.Models.Configuration.updated?(~w(one.md some_other.md)) false iex&gt; Blogit.Models.Configuration.updated?(~w(one.md blog.yml)) true","ref":"Blogit.Models.Configuration.html#updated?/1","title":"Blogit.Models.Configuration.updated?/1","type":"function"},{"doc":"","ref":"Blogit.Models.Configuration.html#t:string_or_nil/0","title":"Blogit.Models.Configuration.string_or_nil/0","type":"type"},{"doc":"","ref":"Blogit.Models.Configuration.html#t:t/0","title":"Blogit.Models.Configuration.t/0","type":"type"},{"doc":"A module holding the representation of a post in a blog and helper functions for it. The Blogit.Models.Post struct contains an unique name of the post, which identifies it, the raw content of the post in markdown, html version of the post content and meta information. The meta information is contained in a Blogit.Models.Post.Meta struct. Usually a post is created by invoking the Blogit.Models.Post.from_file/2 function. This function takes a module implementing the Blogit.RepositoryProvider behaviour for access to a repository, a file path and a Blogit.RepositoryProvider struct. It uses them to read the file and generate the Bogit.Models.Post struct. The Blogit.Models.Post.compile_posts/2 function is able to create a list of multiple Blogit.Models.Post structs using a list of files and a Blogit.RepositoryProvider struct. The module contains a set of utility methods for working with Blogit.Models.Post structs.","ref":"Blogit.Models.Post.html","title":"Blogit.Models.Post","type":"module"},{"doc":"Calculates a list of tuples of three elements from the given list of posts. The first element of a tuple is a year. The second is a month number. The third is a counter - how many posts are created during that month and that year. The tuples are sorted from the newest to the oldest, using the years and the months. Examples iex&gt; alias Blogit.Models.Post.Meta iex&gt; posts = [ ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{created_at: ~N[2016-04-14 22:23:12]} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{created_at: ~N[2017-04-22 14:53:45]} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{created_at: ~N[2017-02-01 07:42:56]} ...&gt; }, ...&gt; %Blogit.Models.Post{ ...&gt; name: &quot;&quot;, raw: &quot;&quot;, html: &quot;&quot;, ...&gt; meta: %Meta{created_at: ~N[2017-04-20 12:23:12]} ...&gt; } ...&gt; ] iex&gt; Blogit.Models.Post.collect_by_year_and_month(posts) [{2017, 4, 2}, {2017, 2, 1}, {2016, 4, 1}]","ref":"Blogit.Models.Post.html#collect_by_year_and_month/1","title":"Blogit.Models.Post.collect_by_year_and_month/1","type":"function"},{"doc":"Returns a map of maps. For every supported language, returned by invoking Blogit.Settings.languages/0, the result of a call to this function will have a key, representing it. The value for every such key will be a map with keys the names of the posts created from parsing the files in the directory representing the language in the given list of paths and values the post structs created. Uses from_file/2 to parse the files and create the Blogit.Models.Post structs. Skips all the non-markdown files as well as the ones that mark the post content as not published or does not exist in the given repository.","ref":"Blogit.Models.Post.html#compile_posts/2","title":"Blogit.Models.Post.compile_posts/2","type":"function"},{"doc":"Creates a Blogit.Models.Post struct from a file stored in a repository. The name of the file is used as the name of the post. For example the struct created from the file some_post.md will have post.name == &quot;some_post&quot;. The given file_path should be located in the given repository. The result struct will have meta created by invoking Blogit.Models.Post.Meta.from_file/5 with the given file_path, repository and language, the name of the post and the markdown data read from the file. If the source file located at the given file_path doesn&#39;t exist, the atom :source_file_not_found is returned as a result. If the meta data of the post to be created has published: false, post.html won&#39;t be generated and will be nil.","ref":"Blogit.Models.Post.html#from_file/3","title":"Blogit.Models.Post.from_file/3","type":"function"},{"doc":"Retrieves unique names, which can be used as names of posts, from a list of file names. Examples iex&gt; Blogit.Models.Post.names_from_files([&quot;SomeFile.md&quot;, &quot;another.md&quot;]) ...&gt; |&gt; Enum.map(&amp;(elem(&amp;1, 1))) [:somefile, :another] iex&gt; Blogit.Models.Post.names_from_files([&quot;one/two/name.md&quot;]) ...&gt; |&gt; Enum.map(&amp;(elem(&amp;1, 1))) [:one_two_name]","ref":"Blogit.Models.Post.html#names_from_files/1","title":"Blogit.Models.Post.names_from_files/1","type":"function"},{"doc":"","ref":"Blogit.Models.Post.html#t:from_file_result/0","title":"Blogit.Models.Post.from_file_result/0","type":"type"},{"doc":"","ref":"Blogit.Models.Post.html#t:t/0","title":"Blogit.Models.Post.t/0","type":"type"},{"doc":"","ref":"Blogit.Models.Post.html#t:year_month_count_result/0","title":"Blogit.Models.Post.year_month_count_result/0","type":"type"},{"doc":"Represents the meta-data of a post. Provides a function to read/parse the meta information from a file. All the meta-fields have default values. The meta information can be stored at the top of the markdown file&#39;s content in YAML format. The markdown content and meta-data are divided using the ---. This yml meta data has the highest priority when Blogit.Models.Post.Meta struct is created from a post source file. With lower priority are the defaults and values read from the repository containing the file.","ref":"Blogit.Models.Post.Meta.html","title":"Blogit.Models.Post.Meta","type":"module"},{"doc":"Creates a Blogit.Models.Post.Meta struct using the source file of a post, its raw data, the language of the post, the name of the post and the repository containing the blog data. The given raw_meta should be list with two elements, the first element should be an YAML string containing the meta-data and the second the post&#39;s raw content.","ref":"Blogit.Models.Post.Meta.html#from_file/5","title":"Blogit.Models.Post.Meta.from_file/5","type":"function"},{"doc":"Sorts a list of Blogit.Models.Post.Meta strucs by the given field. The field can be either :created_at or updated_at. By default this field is created_at. Note that the sort is descending. Examples iex&gt; alias Blogit.Models.Post.Meta iex&gt; metas = [ ...&gt; %Meta{created_at: ~N[2017-02-14 22:23:12], name: &quot;meta1&quot;}, ...&gt; %Meta{created_at: ~N[2017-04-22 14:53:45], name: &quot;meta2&quot;}, ...&gt; %Meta{created_at: ~N[2017-03-01 07:42:56], name: &quot;meta3&quot;} ...&gt; ] iex&gt; Meta.sorted(metas) |&gt; Enum.map(fn (meta) -&gt; meta.name end) ~w[meta2 meta3 meta1] iex&gt; alias Blogit.Models.Post.Meta iex&gt; metas = [ ...&gt; %Meta{updated_at: ~N[2017-03-01 07:42:56], name: &quot;meta2&quot;}, ...&gt; %Meta{updated_at: ~N[2017-02-14 22:23:12], name: &quot;meta1&quot;}, ...&gt; %Meta{updated_at: ~N[2017-04-20 12:23:12], name: &quot;meta3&quot;} ...&gt; ] iex&gt; Meta.sorted(metas, :updated_at) |&gt; Enum.map(&amp;(&amp;1.name)) ~w[meta3 meta2 meta1]","ref":"Blogit.Models.Post.Meta.html#sorted/2","title":"Blogit.Models.Post.Meta.sorted/2","type":"function"},{"doc":"","ref":"Blogit.Models.Post.Meta.html#t:t/0","title":"Blogit.Models.Post.Meta.t/0","type":"type"},{"doc":"A behaviour module for implementing access to remote or local repository containing files which can be used as a source for a blog and its posts. A provider to a repository should be able to check if files exist in it, if files were updated or deleted, to check the author of a file and its dates of creation and last update. Also it should provide a way to read a file and its meta data. A repository provider can be set for the Blogit OTP application using the configuration key :repository_provider. By default it is Blogit.RepositoryProviders.Git. An example of implementing this behaviour could be a local folder. When new files are added, modified and removed the Blogit.RepositoryProvider.fetch/1 should have in its result the paths of these files. The meta data of the file can be used as meta data and creation and last update dates. The author of the file could be its owner. The Blogit.RepositoryProvider struct could contain absolute path to the parent folder of the folder representing the repository and the Blogit.RepositoryProvider.local_path/0 could return its name. For now Blogit comes with two implementations. Blogit.RepositoryProvider.Git provides access to Git repository and is the default provider if none is specified in the configuration. Blogit.RepositoryProvider.Memory provides access to in-memory repository, which can be used (and is used) mainly for testing purposes.","ref":"Blogit.RepositoryProvider.html","title":"Blogit.RepositoryProvider","type":"behaviour"},{"doc":"Invoked to update the data represented by the given repository to its most recent version. If, for example the repository is remote, all the files in it should be downloaded so their most recent versions are accessible. Returns the path to the changed files in the form of the tuple {:updates, list-of-paths}. These paths should be paths to deleted, updated or newly created files.","ref":"Blogit.RepositoryProvider.html#c:fetch/1","title":"Blogit.RepositoryProvider.fetch/1","type":"callback"},{"doc":"Checks if a file path is contained in the local version of the repository.","ref":"Blogit.RepositoryProvider.html#c:file_in?/1","title":"Blogit.RepositoryProvider.file_in?/1","type":"callback"},{"doc":"Returns file information for the file located at the given file_path in the given repository. The result should be in the form of a map and should be structured like this: %{ &quot;author&quot; =&gt; the-file-author, &quot;created_at&quot; =&gt; the-date-the-file-was-created-in-iso-8601-format, &quot;updated_at&quot; =&gt; the-date-of-the-last-update-of-the-file-in-iso-8601-format }","ref":"Blogit.RepositoryProvider.html#c:file_info/2","title":"Blogit.RepositoryProvider.file_info/2","type":"callback"},{"doc":"Invoked to get a list of file paths of set of files contained in the locally downloaded repository.","ref":"Blogit.RepositoryProvider.html#c:list_files/1","title":"Blogit.RepositoryProvider.list_files/1","type":"callback"},{"doc":"Invoked to get the path to the locally downloaded data. If the repository is remote, it should have local copy or something like that.","ref":"Blogit.RepositoryProvider.html#c:local_path/0","title":"Blogit.RepositoryProvider.local_path/0","type":"callback"},{"doc":"Invoked in order to read the contents of the file located at the given file_path. The second parameter can be a path to a folder relative to Blogit.RepositoryProvider.local_path/0 in which the given file_path should exist.","ref":"Blogit.RepositoryProvider.html#c:read_file/2","title":"Blogit.RepositoryProvider.read_file/2","type":"callback"},{"doc":"Invoked to get a representation value of the repository the provider manages. The actual data represented by this struct should be updated to its newest version first. If for example the repository is remote, all the files in it should be downloaded so their most recent versions are accessible. This structure can be passed to other callbacks in order to manage files in the repository.","ref":"Blogit.RepositoryProvider.html#c:repository/0","title":"Blogit.RepositoryProvider.repository/0","type":"callback"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:fetch_result/0","title":"Blogit.RepositoryProvider.fetch_result/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:file_path/0","title":"Blogit.RepositoryProvider.file_path/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:file_read_result/0","title":"Blogit.RepositoryProvider.file_read_result/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:folder/0","title":"Blogit.RepositoryProvider.folder/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:provider/0","title":"Blogit.RepositoryProvider.provider/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:repository/0","title":"Blogit.RepositoryProvider.repository/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:t/0","title":"Blogit.RepositoryProvider.t/0","type":"type"},{"doc":"","ref":"Blogit.RepositoryProvider.html#t:timestamp/0","title":"Blogit.RepositoryProvider.timestamp/0","type":"type"},{"doc":"This module implements the Blogit.RepositoryProvider behaviour. It provides access to a git repository. If the git repository is not accessible in the moment the locally checked one will be used and won&#39;t be updated. The URL to the git repository have to be specified using the :blogit setting :repository_url in the configuration. For the author of a file is used the creator of the file in the git repository. For creation date is used the date of the first commit of the file and for the last update date is used the date of the last commit of the file. The Blogit.RepositoryProvider.repository/0 implementation does git pull before returning the repository representation. The Blogit.RepositoryProvider.fetch/1 implementation uses git fetch to check for deleted, added or updated files.","ref":"Blogit.RepositoryProviders.Git.html","title":"Blogit.RepositoryProviders.Git","type":"module"},{"doc":"Callback implementation for Blogit.RepositoryProvider.fetch/1.","ref":"Blogit.RepositoryProviders.Git.html#fetch/1","title":"Blogit.RepositoryProviders.Git.fetch/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.file_in?/1.","ref":"Blogit.RepositoryProviders.Git.html#file_in?/1","title":"Blogit.RepositoryProviders.Git.file_in?/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.file_info/2.","ref":"Blogit.RepositoryProviders.Git.html#file_info/2","title":"Blogit.RepositoryProviders.Git.file_info/2","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.list_files/1.","ref":"Blogit.RepositoryProviders.Git.html#list_files/1","title":"Blogit.RepositoryProviders.Git.list_files/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.local_path/0.","ref":"Blogit.RepositoryProviders.Git.html#local_path/0","title":"Blogit.RepositoryProviders.Git.local_path/0","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.read_file/2.","ref":"Blogit.RepositoryProviders.Git.html#read_file/2","title":"Blogit.RepositoryProviders.Git.read_file/2","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.repository/0.","ref":"Blogit.RepositoryProviders.Git.html#repository/0","title":"Blogit.RepositoryProviders.Git.repository/0","type":"function"},{"doc":"This module implements the Blogit.RepositoryProvider behaviour. It provides in-memory repository access which can be used for testing. The repository is just an Agent process, so messages could be sent to it in order to add or remove data to or from it.","ref":"Blogit.RepositoryProviders.Memory.html","title":"Blogit.RepositoryProviders.Memory","type":"module"},{"doc":"Stores a file in the in-memory repository. Returns the state of the in-memory repository before the addition.","ref":"Blogit.RepositoryProviders.Memory.html#add_file/1","title":"Blogit.RepositoryProviders.Memory.add_file/1","type":"function"},{"doc":"Adds a file to the in-memory repository using the given file_path as path to the file to create and the given data as its contents. Returns the state of the repository before the modification.","ref":"Blogit.RepositoryProviders.Memory.html#add_file/2","title":"Blogit.RepositoryProviders.Memory.add_file/2","type":"function"},{"doc":"Deletes a file from the in-memory repository. Returns the state of the repository before the modification.","ref":"Blogit.RepositoryProviders.Memory.html#delete_file/1","title":"Blogit.RepositoryProviders.Memory.delete_file/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.fetch/1.","ref":"Blogit.RepositoryProviders.Memory.html#fetch/1","title":"Blogit.RepositoryProviders.Memory.fetch/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.file_in?/1.","ref":"Blogit.RepositoryProviders.Memory.html#file_in?/1","title":"Blogit.RepositoryProviders.Memory.file_in?/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.file_info/2.","ref":"Blogit.RepositoryProviders.Memory.html#file_info/2","title":"Blogit.RepositoryProviders.Memory.file_info/2","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.list_files/1.","ref":"Blogit.RepositoryProviders.Memory.html#list_files/1","title":"Blogit.RepositoryProviders.Memory.list_files/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.local_path/0.","ref":"Blogit.RepositoryProviders.Memory.html#local_path/0","title":"Blogit.RepositoryProviders.Memory.local_path/0","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.read_file/2.","ref":"Blogit.RepositoryProviders.Memory.html#read_file/2","title":"Blogit.RepositoryProviders.Memory.read_file/2","type":"function"},{"doc":"Replaces an existing file&#39;s content with new content. If the file doesn&#39;t exist, creates it. Returns the state of the repository before the modification.","ref":"Blogit.RepositoryProviders.Memory.html#replace_file/1","title":"Blogit.RepositoryProviders.Memory.replace_file/1","type":"function"},{"doc":"Callback implementation for Blogit.RepositoryProvider.repository/0.","ref":"Blogit.RepositoryProviders.Memory.html#repository/0","title":"Blogit.RepositoryProviders.Memory.repository/0","type":"function"},{"doc":"Starts the memory repository as a process. The process is named and its name is the name of this module. Accepts argument of type Blogit.RepositoryProviders.Memory.t. By default the repository is empty.","ref":"Blogit.RepositoryProviders.Memory.html#start_link/1","title":"Blogit.RepositoryProviders.Memory.start_link/1","type":"function"},{"doc":"Stops the in-memory repository process.","ref":"Blogit.RepositoryProviders.Memory.html#stop/0","title":"Blogit.RepositoryProviders.Memory.stop/0","type":"function"},{"doc":"","ref":"Blogit.RepositoryProviders.Memory.html#t:t/0","title":"Blogit.RepositoryProviders.Memory.t/0","type":"opaque"},{"doc":"This module represents the core process of Blogit. The process is responsible for loading the blog data from a repository, using specified Blogit.RepositoryProvider implementation and keeping it converted into structures. The component processes use these structures as their state. If polling is configured to true, this process polls for changes in the source repository on interval, configured with poll_interval. By default this interval is 10 seconds. This process is started and supervised as worker by Blogit.Supervisor. It uses Task processes to check for updated, which are supervised by the Task.Supervisor process, started and supervised by Blogit.Supervisor. If there are changes in the source repository, it is this process&#39; responsibility to update the component processes. The component processes are added as workers by this process to the Blogit.Components.Supervisor, which starts with no workers. This is so, because they are dependent on the Blogit.Server process and it must be started and ready to accept messages before them.","ref":"Blogit.Server.html","title":"Blogit.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Server.html#child_spec/1","title":"Blogit.Server.child_spec/1","type":"function"},{"doc":"Retrives part of the state of the Blogit.Server process - the Blogit.Models.Configuration struct it holds for the given language. Sends a call to the {:get_configuration, language} call handler of the process.","ref":"Blogit.Server.html#get_configuration/1","title":"Blogit.Server.get_configuration/1","type":"function"},{"doc":"Retrives part of the state of the Blogit.Server process - the list of Blogit.Models.Post structs it holds for the given language. Sends a call to the {:get_posts, language} call handler of the process.","ref":"Blogit.Server.html#get_posts/1","title":"Blogit.Server.get_posts/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Blogit.Server.html#init/1","title":"Blogit.Server.init/1","type":"function"},{"doc":"Starts the Blogit.Server process. This function has one argument - a module which must implement the Blogit.RepositoryProvider behaviour. It is used to read data from the source repository and to check for updates. Once the process starts, it reads all the data from the repository, using the given provider, converts it to Blogit.Models structures and creates the component processes. Every component process should retrieve the data it needs from the Blogit.Server process. When there are updates, the blogit server will update its components.","ref":"Blogit.Server.html#start_link/1","title":"Blogit.Server.start_link/1","type":"function"},{"doc":"","ref":"Blogit.Server.html#t:t/0","title":"Blogit.Server.t/0","type":"type"},{"doc":"Provides application-wide settings for Blogit. All of the functions in this modules are settings, which can be reused through the other modules.","ref":"Blogit.Settings.html","title":"Blogit.Settings","type":"module"},{"doc":"Returns a list of the additional or secondary languages configured for Bogit. These are all the language without the first one from :languages configuration like this one: config :blogit, repository_url: some-url, repository_provider: some-provider, languages: ~w(bg en) By default it is an empty list. Examples iex&gt; Application.put_env(:blogit, :languages, [&quot;es&quot;, &quot;bg&quot;, &quot;de&quot;]) iex&gt; Blogit.Settings.additional_languages() [&quot;bg&quot;, &quot;de&quot;] iex&gt; Application.delete_env(:blogit, :languages) # Use default iex&gt; Blogit.Settings.additional_languages() []","ref":"Blogit.Settings.html#additional_languages/0","title":"Blogit.Settings.additional_languages/0","type":"function"},{"doc":"Returns the path to the configuration file of Blogit. It can be configured like this: config :blogit, repository_url: some-url, repository_provider: some-provider, configuration_file: path-to-the-file.yml By default it is in the root of the repository and called &#39;blog.yml&#39;. Examples iex&gt; Application.put_env(:blogit, :configuration_file, &quot;my_conf.yml&quot;) iex&gt; Blogit.Settings.configuration_file() &quot;my_conf.yml&quot; iex&gt; Application.delete_env(:blogit, :configuration_file) # Use default iex&gt; Blogit.Settings.configuration_file() &quot;blog.yml&quot;","ref":"Blogit.Settings.html#configuration_file/0","title":"Blogit.Settings.configuration_file/0","type":"function"},{"doc":"Returns the default language configured for Blogit. This is the first language in the list of languages configured like this: config :blogit, repository_url: some-url, repository_provider: some-provider, languages: ~w(bg en) By default it is &quot;en&quot; for English. Examples iex&gt; Application.put_env(:blogit, :languages, [&quot;bg&quot;, &quot;de&quot;]) iex&gt; Blogit.Settings.default_language() &quot;bg&quot; iex&gt; Application.delete_env(:blogit, :languages) # Use default iex&gt; Blogit.Settings.default_language() &quot;en&quot;","ref":"Blogit.Settings.html#default_language/0","title":"Blogit.Settings.default_language/0","type":"function"},{"doc":"Retrieves the list of supported languages configured for Blogit. The languages can be configured like this: config :blogit, repository_url: some-url, repository_provider: some-provider, languages: ~w(bg en) For every configured language a separate set of posts and blog configuration is kept. Every language has its own Blogit.Components.* processes running, that can be queried. By default the list of languages is [&quot;en&quot;]. Examples iex&gt; Application.put_env(:blogit, :languages, [&quot;bg&quot;]) iex&gt; Blogit.Settings.languages() [&quot;bg&quot;] iex&gt; Application.delete_env(:blogit, :languages) # Use default iex&gt; Blogit.Settings.languages() [&quot;en&quot;]","ref":"Blogit.Settings.html#languages/0","title":"Blogit.Settings.languages/0","type":"function"},{"doc":"Returns how many lines of the source file of a post should be used for generating its preview. Can be configured in the Blogit configuration: config :blogit, repository_url: some-url, repository_provider: some-provider, max_lines_in_preview: 30 If not configured its default value is 10. Examples iex&gt; Application.put_env(:blogit, :max_lines_in_preview, 30) iex&gt; Blogit.Settings.max_lines_in_preview() 30 iex&gt; Application.delete_env(:blogit, :max_lines_in_preview) # Use default iex&gt; Blogit.Settings.max_lines_in_preview() 10","ref":"Blogit.Settings.html#max_lines_in_preview/0","title":"Blogit.Settings.max_lines_in_preview/0","type":"function"},{"doc":"Returns the string &quot;\\n---\\n&quot; - the divider used to separate the meta data from the post content in the post markdown files. It&#39;s advisable to have it on two places - before and after the metadata: --- author: Dali --- # My meta content Examples iex&gt; Blogit.Settings.meta_divider() &quot;\\n---\\n&quot;","ref":"Blogit.Settings.html#meta_divider/0","title":"Blogit.Settings.meta_divider/0","type":"function"},{"doc":"Returns the interval used when polling the source repository for changes. It is used only if Blogit.Settings.polling?() returns true. The value is the interval in milliseconds. The configuration is specified in seconds, like this: config :blogit, repository_url: some-url, repository_provider: some-provider, polling: true, poll_interval: 50 The default is 10_000 for ten seconds. Examples iex&gt; Application.put_env(:blogit, :poll_interval, 60) iex&gt; Blogit.Settings.poll_interval() 60_000 iex&gt; Application.delete_env(:blogit, :poll_interval) # Use default iex&gt; Blogit.Settings.poll_interval() 10_000","ref":"Blogit.Settings.html#poll_interval/0","title":"Blogit.Settings.poll_interval/0","type":"function"},{"doc":"Returns true if polling the source repository for changes is configured to be &#39;on&#39;. That can be done like this: config :blogit, repository_url: some-url, repository_provider: some-provider, polling: true The default is true if it is not configured. Examples iex&gt; Application.put_env(:blogit, :polling, true) iex&gt; Blogit.Settings.polling?() true iex&gt; Application.put_env(:blogit, :polling, false) iex&gt; Blogit.Settings.polling?() false iex&gt; Application.delete_env(:blogit, :polling) # Use default iex&gt; Blogit.Settings.polling?() true","ref":"Blogit.Settings.html#polling?/0","title":"Blogit.Settings.polling?/0","type":"function"},{"doc":"Returns the string &quot;posts&quot; - the location of the posts folder in the repository. A custom provider can opt to not use this default location, but the Blogit.RepositoryProviders.Git provider expects posts to be located in a folder named posts in the root of the repository. Examples iex&gt; Blogit.Settings.posts_folder() &quot;posts&quot;","ref":"Blogit.Settings.html#posts_folder/0","title":"Blogit.Settings.posts_folder/0","type":"function"},{"doc":"This module represents the root Supervisor of Blogit. It uses a one_for_all strategy to supervise its children. The children are: Blogit.Server worker used as the core process of Blogit. If it fails all the top-level processes of the application must be restarted, thus the one_for_all strategy. Blogit.Components.Supervisor supervisor which supervises the components of Blogit that can be queried. If this process fails it will be good to restart all the top-level processes, because the Blogit.Server process is used by the components to manage their data. A Task.Supervisor used to supervise all the Tasks in Blogit. If the Applications is using the Blogit.RepositoryProviders.Memory provider, a worker representing the in-memory repository is started and supervised too. Blogit.Supervisor is started in Blogit.start/2 using Blogit.Supervisor.start_link/1 and the result of this call is what the start function of the Blogit application returns.","ref":"Blogit.Supervisor.html","title":"Blogit.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Blogit.Supervisor.html#child_spec/1","title":"Blogit.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Blogit.Supervisor.html#init/1","title":"Blogit.Supervisor.init/1","type":"function"},{"doc":"Accepts a module implementing Blogit.RepositoryProvider and starts the supervisor defined by this module. The Blogit.RepositoryProvider module is passed to the Supervisor.init/1 callback implemented by this module and is used to create and start the Blogit.Server worker. This function is called by Blogit.start/2 and its result is returned by it.","ref":"Blogit.Supervisor.html#start_link/1","title":"Blogit.Supervisor.start_link/1","type":"function"},{"doc":"Blogit Blogit is a blog engine back-end written in Elixir. It turns a repository (by default git repository), containing markdown files into streams of blog posts, which can be queried. Blogit supports blog configuration in YAML, including blog title, path to custom styles and images, etc. There is a front-end implementation in Phoenix, which uses Blogit - BlogitWeb. It can be forked and configured to use any repository to build custom blog. The blog for the Sofia University Elixir course runs on Blogit.","ref":"readme.html","title":"Blogit","type":"extras"},{"doc":"It is available in Hex, so the package can be installed: Add blogit to your list of dependencies in mix.exs: def deps do [{:blogit, &quot;~&gt; 1.2&quot;}] end Ensure blogit is started before your application: def application do [applications: [:blogit]] end","ref":"readme.html#installation","title":"Blogit - Installation","type":"extras"},{"doc":"An example configuration for blogit is: config :blogit, repository_url: &quot;https://github.com/ElixirCourse/blog.git&quot;, polling: true, poll_interval: 300, languages: ~w(en bg de) Possible settings are: repository_url |&gt; Tells Blogit the location of the repository to use to build its contents. polling |&gt; Tells Blogit if it should poll the repository specified through repository_url for changes. By default it is true. poll_interval |&gt; Used if polling is set to true. The polling for changes will happen on this interval of seconds. By default it is 10 seconds. repository_provider |&gt; Specified a specific implementation of the Blogit.RepositoryProvider behaviour. By default it uses Blogit.RepositoryProviders.Git which works with git repositories and knows how to check for changes in them. configuration_file |&gt; Path to YAML file in the repository, which contains configuration for the blog. By default it is blog.yml. languages |&gt; A list of language codes. By default it is [&quot;en&quot;]. The first language of the list is the default and primaty language. If there are alternative languages, if post source files are created in the folder &lt;repo-root&gt;/posts/&lt;lang-code&gt;, the posts compiled from them are marked that are in the given language. They can be queried with Blogit.list_posts(language: &quot;&lt;lang-code&gt;&quot;). max_lines_in_preview |&gt; The maximum lines to be used from the content of the original post source to generate its preview. The preview is generated from the beginning of the content and contains maximum max_lines_in_preview lines. By default this value is 10. Using these settings a custom blog can be created from whatever repository. It is not hard to write FTP repository provider or Ecto repository provider.","ref":"readme.html#configuration","title":"Blogit - Configuration","type":"extras"},{"doc":"Blogit has a public interface which can be used to build a blog similar to BlogitWeb. When the application is configured and started, the following functions can be called: Blogit.list_posts(options) Returns a list of Blogit.Models.Post.Meta structs representing posts previews in the blog. The posts are sorted by their creation date, newest first. All the markdown files in the folder &lt;repo-root&gt;/posts will be transformed into Blogit.Models.Post structs and their created_at meta field will be read using the configured Blogit.RepositoryProvider. Post previews can be skipped using the from option, which is 0 by default. The size of the returned list is :infinity by default (meaning &quot;return all post previews&quot;), but it can be changed with the size option to a number. By using these two options simple paging functionality can be implemented. Another supported option is language. It defaults to the default language (the first one in the configured languages list). A stream of post previews for the given language will be returned. Examples: # All post previews in the default language post_previews = Blogit.list_posts() # The first 5 post previews in the default language post_previews = Blogit.list_posts(size: 5) # The second 5 post previews in the default language post_previews = Blogit.list_posts(size: 5, from: 5) # All post previews in Bulgarian post_previews = Blogit.list_posts(language: &quot;bg&quot;) # The second 5 post previews in Bulgarian post_previews = Blogit.list_posts(language: &quot;bg&quot;, size: 5, from: 5) Blogit.list_pinned(options) Returns a list of tuples. Every such tuple has the unique name of a post as first element and its title as second. These tuples are sorted by the last updated date of the posts they represent. All the markdown files in the source posts folder will be transformed into Blogit.Models.Post strucs and their updated_at meta field will be read using the configured Blogit.RepositoryProvider. Pinned posts are posts which have specified pinned: true in their meta data. These are special posts which should be easy to find in the front-end implementation. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Pinned post tuples for the given language will be returned. Examples: # Pinned post tuples for the default language Blogit.list_pinned() # Pinned post tuples for posts in German Blogit.list_pinned(language: &quot;de&quot;) Blogit.filter_posts(filters, options) Returns a list of Blogit.Models.Post.Meta structs, filtered by the given filters. The first argument of the function is a map of filters. This map supports zero or more of the following keys: &quot;author&quot; - Used to filter posts by their .meta.author field. &quot;category&quot; - Used to filter posts by their .meta.category field. &quot;tags&quot; - Used to filter posts by their .meta.tags field. The value for this key should a string of comma separated tags (&quot;one,two,three&quot;). &quot;year&quot; - Used to filter posts by their .meta.year field. &quot;month&quot; - Used to filter posts by their .meta.month field. &quot;q&quot; - A query to filter posts by their content or title. Supports text in double quotes in order to search for phrases. All these keys must be strings. Filtered post previews can be skipped using the from option, which is 0 by default. The size of the returned list is :infinity by default (meaning &quot;return all filtered post previews&quot;), but it can be changed with the size option to a number. By using these two options simple paging functionality can be implemented. Another supported option is language. It defaults to the default language (the first one in the configured languages list). A stream of post previews, filtered by the given filters for the given language will be returned. Examples: # All the post previews in the default language, filtered by the given `filters` filters = %{&quot;q&quot; =&gt; &quot;OTP&quot;, &quot;author&quot; =&gt; &quot;meddle&quot;, &quot;tags&quot; =&gt; &quot;ab&quot;} Blogit.filter_posts(filters) # The second two post previews in German, filtered by the given `filters` filters = %{&quot;q&quot; =&gt; &quot;OTP&quot;, &quot;author&quot; =&gt; &quot;meddle&quot;, &quot;tags&quot; =&gt; &quot;ab&quot;} Blogit.filter_posts(filters, language: &quot;de&quot;, from: 2, size: 2) Blogit.posts_by_dates(options) Returns a list of tuples of three elements from the given list of posts. The first element of a tuple is a year. The second is a month number. The third is a counter - how many posts are created during that month and that year. The tuples are sorted from the newest to the oldest, using the years and the months. Can be used for implementing an easy-to-browse view component by years/months. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Statistics for the posts in the given language will be returned. Examples: # Statistics for the posts in the default language posts_by_date = Blogit.posts_by_dates() # [{2017, 6, 5}, {2017, 5, 1}, {2016, 5, 1}] # Statistics for the posts in Bulgarian posts_by_date = Blogit.posts_by_dates(language: &quot;bg&quot;) # [{2017, 5, 1}, {2016, 5, 1}] Blogit.post_by_name(name, options) Returns a single post by its unique identifier - its name field. The name should be an atom. The result is in the form {:ok, post} if a post with the given name exist for the given (or default) language. The post element of that tuple is a Blogit.Models.Post struct. Posts have unique names, usually constructed using the file path of their source markdown file in the repository. If there is no post with the given name, the tuple {:error, &quot;No post with name the-passed-name found.&quot;} is returned. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Post with the given name in the given language will be returned if found. Examples: # A post with the name `:otp`, written in the default language {:ok, post} = Blogit.post_by_name(:otp) IO.puts post.name # :otp IO.puts post.meta.author # The author of the post IO.puts post.raw # The source markdown of the post # A post with the name `:otp`, written in Bulgarian {:ok, post} = Blogit.post_by_name(:otp, language: &quot;bg&quot;) Blogit.configuration(options) Retrieves the blog configuration. The configuration is in the form of a Blogit.Models.Configuration struct. It contains title and sub-title of the blog, path to logo or background image (or both), path to custom CSS file, etc.. The configuration is generated from an YAML file (by default blog.yml, stored in the root of the repository of the blog). This location can be configured through setting the :configuration_file key of the :blogit configuration. The only supported option is language. It defaults to the default language (the first one in the configured languages list). Configuration for the given language will be returned. Examples: # The configuration of the blog for the default language Blogit.configuration() # The configuration for the German part of the blog Blogit.configuration(language: &quot;de&quot;)","ref":"readme.html#usage","title":"Blogit - Usage","type":"extras"},{"doc":"The license is standard MIT license, feel free to fork Blogit and do whatever you want with it. You can also contribute to it.","ref":"readme.html#license","title":"Blogit - License","type":"extras"},{"doc":"Just fork the Blogit repository and create a PR. You can also create issues with features you wish we support. You can propose style changes on the code and additional tests. All kinds of contributions are welcome!","ref":"readme.html#contributions","title":"Blogit - Contributions","type":"extras"},{"doc":"Blogit has a simple Phoenix front-end application : BlogitWeb. Follow these steps to create your own blog (read more at BlogitWeb&#39;s README): Fork BlogitWeb project. Modify its config/prod.exs configuration: config :blogit, repository_url: &quot;&lt;path-to-a-git-repository-with-your-posts&gt;&quot;, polling: true, poll_interval: 300 Recompile the dependencies, so the configuration is updated: mix deps.get mix deps.clean mix deps.compile Deploy it somewhere. BlogitWeb depends on distillery and has a little bash script in its root, called build_release.sh. Just run it and it will build a release. You can also run it like this : ./build_release.sh --upgrade in order to create updated release. Follow distillery&#39;s notes when deploying.&#39; BlogitWeb has a Dockerfile.build file which can be used to make a build in Docker if you don&#39;t have Elixir installed. It has a Dockerfile too so you can try it locally. There is a template edeliver configuration too. When it is deployed just add new markdown posts to your repository specified in the configuration and it will be published automatically.","ref":"readme.html#how-to-create-your-own-blog","title":"Blogit - How to create your own blog?","type":"extras"},{"doc":"Pages (for example &#39;about me&#39;) and specific streams of posts, presented as pages. Slides. If we have a folder containing a specifically formated markdown (?) files, they could be turned into slides available on Blogit. Different front-ends for Blogit. Not only BlogtWeb. Also let&#39;s keep BlogitWeb up to date, tested and documented. For now it is a bit messy, but usable. Multiple source formats for posts, not only MARKDOWN. Additional repository providers.","ref":"readme.html#features-to-be-implemented","title":"Blogit - Features to be implemented","type":"extras"},{"doc":"I&#39;m Nikolay Tsvetinov (meddle) from elixir-lang.bg. You can find me at: Twitter Github Gmail elixir-lang.bg My blog, implemented using Blogit","ref":"readme.html#contact-me","title":"Blogit - Contact me","type":"extras"}]